.code
.proc MainLoop
forever:
  lda #OBJ_ON+BG_ON
  sta PPUMASK

  jsr wait_vblank
  jsr ReadJoy

  lda keydown ; pause routine
  ora keydown+1
  and #KEY_START
  beq NoPause
    lda keynew
    ora keynew+1
    and #KEY_START
    beq NoPause
      jsr stop_music
      jsr update_sound
      lda #BG_ON|OBJ_ON|1
      sta PPUMASK
:     jsr ReadJoy
      stx TempVal
      jsr update_sound
      ldx TempVal
      lda keydown
      ora keydown+1
      and #KEY_START
      bne :-
      ldx #15
    : jsr wait_vblank
      stx TempVal
      jsr update_sound
      ldx TempVal
      dex
      bne :-
:     jsr ReadJoy
      stx TempVal
      jsr update_sound
      ldx TempVal
      lda keydown
      ora keydown+1
      and #KEY_START
      beq :-
:     jsr ReadJoy
      lda keydown
      ora keydown+1
      and #KEY_START
      bne :-
      ldx #15
    : jsr wait_vblank
      dex
      bne :-
      lda #1
      sta music_playing
  NoPause:
;  lda #OBJ_ON+BG_ON+%11100000
;  sta PPUMASK

  lda retraces
  and #15
  bne :+
    inc retraces_16th
  :

  lda #1
  sta EnableNMIDraw
  sta DoControllerSwap
  bit PPUSTATUS
  lda #0
  sta PPUSCROLL
  sta PPUSCROLL

  jsr ClearOAM

  jsr update_sound
  jsr SpawnEnemies

  ldx #0
  jsr HandlePlayer
  jsr DispPlayer

  jsr RunObjects
  lda NeedSound
  bmi :+
    jsr start_sound
    lda #-1
    sta NeedSound
  :
  jsr RunBullets
  jsr RunExplosions
  jsr UpdateStatus

  ldx #0
MetaEditLoop:
  lda DelayedMetaEditType,x
  beq SkipMetaEdit
    lda retraces_16th
    cmp DelayedMetaEditTime,x
    bne SkipMetaEdit
    ldy DelayedMetaEditIndx,x
    lda DelayedMetaEditType,x
    bpl :+
      lda #0
  : jsr ChangeBlock
    lda #0
    sta DelayedMetaEditType,x
SkipMetaEdit:
  inx
  cpx #MaxDelayedMetaEdits
  bne MetaEditLoop

  lda EnemiesLeftForNextLevel
  bne :+
  inc LevelMapNumber
  jmp NewLevel
:

  jmp forever
.endproc

.proc ClearOAM
  lda #$f0
  ldx #0
: sta OAM_YPOS,x
  inx
  inx
  inx
  inx
  bne :-
  rts
.endproc

.proc UpdateStatus
  ldx #0
Loop:
  ldy OamPtr
  lda #10
  sta OAM_YPOS+(4*0),y
  sta OAM_YPOS+(4*1),y
  sta OAM_YPOS+(4*2),y

  lda #20
  sta OAM_YPOS+(4*3),y
  sta OAM_YPOS+(4*4),y
  sta OAM_YPOS+(4*5),y

  lda #10
  sta OAM_XPOS+(4*0),y
  sta OAM_XPOS+(4*3),y

  lda #10+10
  sta OAM_XPOS+(4*1),y
  sta OAM_XPOS+(4*4),y

  lda #10+18
  sta OAM_XPOS+(4*2),y
  sta OAM_XPOS+(4*5),y

  lda #0
  sta OAM_ATTR+(4*0),y
  sta OAM_ATTR+(4*1),y
  sta OAM_ATTR+(4*2),y
  sta OAM_ATTR+(4*3),y
  sta OAM_ATTR+(4*4),y
  sta OAM_ATTR+(4*5),y

  ; ammo symbol
  lda #$34
  sta OAM_TILE+(4*0),y

  ; get BCD version of health and ammo
  sty 0
  ldy PlayerAmmo,x
  lda BCDTable,y
  sta 1
  ldy PlayerHealth,x
  lda BCDTable,y
  sta 2
  ldy 0

  ; ammo number
  lda 1
  lsr
  lsr
  lsr
  lsr
  add #$36
  sta OAM_TILE+(4*1),y
  lda 1
  and #15
  add #$36
  sta OAM_TILE+(4*2),y

  ; health symbol
  lda #$35
  sta OAM_TILE+(4*3),y

  ; display health number
  lda 2
  lsr
  lsr
  lsr
  lsr
  add #$36
  sta OAM_TILE+(4*4),y
  lda 2
  and #15
  add #$36
  sta OAM_TILE+(4*5),y

  tya
  add #4*6
  sta OamPtr
  rts
.endproc

.proc BCDTable
  .byt $00, $01, $02, $03, $04, $05, $06, $07, $08, $09, $10, $11, $12, $13, $14, $15, $16, $17, $18, $19
  .byt $20, $21, $22, $23, $24, $25, $26, $27, $28, $29, $30, $31, $32, $33, $34, $35, $36, $37, $38, $39
  .byt $40, $41, $42, $43, $44, $45, $46, $47, $48, $49, $50, $51, $52, $53, $54, $55, $56, $57, $58, $59
  .byt $60, $61, $62, $63, $64, $65, $66, $67, $68, $69, $70, $71, $72, $73, $74, $75, $76, $77, $78, $79
  .byt $80, $81, $82, $83, $84, $85, $86, $87, $88, $89, $90, $91, $92, $93, $94, $95, $96, $97, $98, $99
.endproc
