.proc RunObjects
  ldx #0
: jsr LaunchA
  inx
  cpx #AObjectLen
  beq B
  jmp :-
B:
.if 0
  ldx #0
: jsr LaunchB
  inx
  cpx #BObjectLen
  beq Exit
  jmp :-
.endif

LaunchA:
  lda AObjectF1,x
  and #31
  beq Exit
  asl
  tay

; push address
  lda AObjectTable+1,y
  pha
  lda AObjectTable+0,y
  pha
  rts

.if 0
LaunchB:
  lda BObjectF1,x
  and #31
  beq Exit
  asl
  tay
  lda BObjectTable+1,y
  pha
  lda BObjectTable+0,y
  pha
.endif
Exit:
  rts
.endproc

.proc EmptyObject
  rts
.endproc

.proc AObjectTable
  .raddr EmptyObject
  .raddr AObject_Spinner
  .raddr AObject_Cannon ; cannon 1
  .raddr AObject_Cannon ; cannon 2
  .raddr AObject_Burger1
  .raddr AObject_Burger1
  .raddr AObject_Burger1
  .raddr EmptyObject
  .raddr EmptyObject
  .raddr AObject_Mine
  .raddr AObject_Pickup ; powerup
  .raddr AObject_Pickup
  .raddr AObject_Pickup
  .raddr AObject_Pickup

  ; padding
  .raddr AObject_Mine
  .raddr AObject_Mine
  .raddr AObject_Mine
  .raddr AObject_Mine
  .raddr AObject_Mine
.endproc

.enum
  AOBJECT_NONE
  AOBJECT_SPINNER
  AOBJECT_CANNON1 ; shoots burger1s
  AOBJECT_CANNON2
  AOBJECT_BURGER1 ; just drift until it hits something
  AOBJECT_BURGER2
  AOBJECT_BURGER3
  AOBJECT_GEORGE
  AOBJECT_KING
  AOBJECT_MINE
  AOBJECT_PICKUP_AMMO
  AOBJECT_PICKUP_HEALTH
  AOBJECT_PICKUP_SPEED
  AOBJECT_PICKUP_BOMB
.endenum

ObjectIsEnemyTable:
  .byt 0
  .byt 1
  .byt 1
  .byt 1
  .byt 1
  .byt 1
  .byt 1
  .byt 1
  .byt 1
  .byt 1
  .byt 0
  .byt 0
  .byt 0
  .byt 0

.proc AObjectShoot
  pha
  lda AObjectPXH,x
  add #4
  sta GunX
  lda AObjectPYH,x
  add #4
  sta GunY
  pla
  jsr ShootFromXY
  rts
.endproc

.proc AObjectAimAtPlayer
  lda AObjectPXH,x
  sta 0
  lda AObjectPYH,x
  sta 1
  lda PlayerPXH
  sta 2
  lda PlayerPYH
  sta 3
  jmp getAngle
.endproc

.proc AObject_Spinner
  lda AObjectF2,x
  cmp #2
  bne NotTeleporting

  jsr huge_rand
  and #63
  sub #32
  add AObjectPXH,x
  sta AObjectPXH,x
  add #8
  pha

  jsr huge_rand
  and #63
  sub #32
  add AObjectPYH,x
  sta AObjectPYH,x
  add #8
  and #$f0
  sta 0
  pla
  lsr
  lsr
  lsr
  lsr
  ora 0
  tay
  lda LevelBuf,y
  bne :+
    lda #0
    sta AObjectF2,x
  :

  ldy #ADRAW_HMIRROR
  lda retraces
  and #8
  lsr
  lsr
  add #$40
  jmp AObjectDrawEx
NotTeleporting:
  lda retraces
  and #3
  bne :+
  jsr huge_rand
  and #%111
  bne :+
    jsr AObjectAimAtPlayer
    sta AObjectAngle,x
: lda retraces
  and LevelSpinShootRate
  bne :+
  jsr huge_rand
  and LevelSpinShootChance
  bne :+
    ldy AObjectAngle,x
    lda LevelSpinShootSpeed
    jsr AObjectShoot
  :

  jsr AObjectPlayerTouch
  jsr AObjectHurtPlayerIfTouched
  jsr AObjectGetShot
  jsr AObjectGetHurtFromShot
  lda #1
  jsr AObjectUpdateVelocity
  lda #0
  sta 0
  jsr AObjectCheckBounce
  lda 0
  beq :+
    jsr huge_rand
    lsr
    lsr
    and #7
    bne :+
      lda #2
      sta AObjectF2,x
  :
  jsr AObjectApplyVelocity
  ldy #ADRAW_HMIRROR
  lda retraces
  and #8
  lsr
  lsr
  add #$40
  jsr AObjectDrawEx
  rts
.endproc

.proc AObject_Cannon
  jsr AObjectPlayerTouch
  jsr AObjectHurtPlayerIfTouched
  jsr AObjectGetShot
  jsr AObjectGetHurtFromShot
  lda #6
  jsr AObjectUpdateVelocity
  jsr AObjectApplyVelocity

  ; shoot
  lda retraces
  and #63
  jne NoShoot
     jsr huge_rand
     lsr
     jcc NoShoot
       jsr AObjectAimAtPlayer
       sta 10
       txa
       pha
       jsr FindFreeAObjectX
       jcc NoShoot
       txa
       tay
       pla
       tax

       lda AObjectPXH,x
       sta AObjectPXH,y
       lda AObjectPYH,x
       sta AObjectPYH,y
       lda #0
       sta AObjectPXL,y
       sta AObjectPYL,y
       sta AObjectVXL,y
       sta AObjectVXH,y
       sta AObjectVYL,y
       sta AObjectVYH,y
       sta AObjectF2,y
       lda #1
       sta AObjectF3,y
       lda #30
       sta AObjectTimer,y
       lda #AOBJECT_BURGER2
       sta AObjectF1,y
       lda 10
       sta AObjectAngle,y
NoShoot:

  ldy #ADRAW_VMIRROR
  lda AObjectPXH,x
  bpl :+
    ldy #ADRAW_VMIRROR|ADRAW_HFLIP
: lda #$54
  jsr AObjectDrawEx
  rts
.endproc

.proc AObject_Burger1
  lda AObjectF1,x
  sub #AOBJECT_BURGER1
  and #31
  sta 10
  jsr AObjectPlayerTouch
  jsr AObjectHurtPlayerIfTouched
  jsr AObjectGetShot
  jsr AObjectGetHurtFromShot
  ldy 10
  lda BaseSpeeds,y
  jsr AObjectUpdateVelocity
  jsr AObjectApplyVelocity
  lda 10
  asl
  asl
  add #$44
  jsr AObjectDraw
  lda 10
  beq :+
  jsr AObjectTimerTick
:
  rts
BaseSpeeds:
  .byt 6, 12, 10
.endproc

.proc AObject_Mine
  jsr AObjectPlayerTouch
  bcs AObjectExplode
  jsr AObjectGetShot
  bcs AObjectExplode
  lda #6
  jsr AObjectUpdateVelocity
  jsr AObjectCheckBounce
  jsr AObjectApplyVelocity
  lda #$5c
  jsr AObjectDraw
  rts
.endproc

.proc AObjectExplode
  lda AObjectPXH,x
  add #8
  sta 0
  lda AObjectPYH,x
  add #8
  sta 1
  lda #30
  jsr CreateExplosion
  lda #SOUND_EXPLODE1
  jsr start_sound
  lda #SOUND_EXPLODE2
  jsr start_sound
  lda #0
  sta AObjectF1,x
  rts
.endproc

; ---------------------------------------------------
.if 0
.proc BObjectTable
  .raddr BObject_Poof
  .raddr BObject_Pickup
  .raddr BObject_Pickup
  .raddr BObject_Pickup
.endproc

.enum
  BOBJECT_NONE
  BOBJECT_POOF
  BOBJECT_PICKUP_AMMO
  BOBJECT_PICKUP_HEALTH
  BOBJECT_PICKUP_SPEED
  BOBJECT_PICKUP_BOMB
.endenum
.endif

.proc AObject_Poof
  jsr AObjectTimerTick
  rts
.endproc

.proc AObject_Pickup
  lda AObjectF1,x
  and #31
  sub #AOBJECT_PICKUP_AMMO
  sta 10

  jsr AObjectPlayerTouch
  jcs Remove

  ldy 10
  lda Images,y
  pha
  lda Flags,y
  tay
  pla
  jsr AObjectDrawEx
  jmp AObjectTimerTick
Images: .byt $20, $22, $24, $28
Flags: .byt ADRAW_HMIRROR, ADRAW_HMIRROR, 0, 0
Remove:
  lda #SOUND_COLLECT
  sta NeedSound
  lda #0
  sta AObjectF1,x
  lda 10
  asl
  tax
  lda PowerUpRoutines+1,x
  pha
  lda PowerUpRoutines+0,x
  pha
  ldy PlayerThatTouched
  rts
PowerUpRoutines:
  .raddr Ammo
  .raddr Health
  .raddr Speed
  .raddr Bomb
Ammo:
  lda PlayerAmmo,y
  add #5
  sta PlayerAmmo,y
  rts
Speed:
  lda #240
  sta PlayerSpeedupTimer,y
  rts
Health:
  lda PlayerHealth,y
  add #10
  cmp #40
  bcc :+
    lda #40
: sta PlayerHealth,y
  rts
Bomb:
;  lda #80
;  sta PlayerInvincible,y
  lda PlayerPXH,y
  sta 0
  lda PlayerPYH,y
  sta 1
  lda #20
  jmp CreateExplosion
.endproc

.proc AObjectTimerTick
  lda retraces
  lsr
  bcc Exit
  lda AObjectTimer,x
  beq Remove
  dec AObjectTimer,x
  beq Remove
  clc
Exit:
  rts
Remove:
  lda #0
  sta AObjectF1,x
  sec
  rts
.endproc

.proc rand_8_safe
  stx TempVal
  jsr rand_8
  ldx TempVal
  rts
.endproc

.proc AObjectHurtPlayerIfTouched
  bcc :+
  lda #3
  jsr HurtPlayer
: rts
.endproc

ADRAW_HMIRROR    = %00000001
ADRAW_VMIRROR    = %00000010
ADRAW_HFLIP      = %00000100

AObjectDraw:
  ldy #0
.proc AObjectDrawEx
Flags = 0
  pha
  sty Flags
  ldy OamPtr

  lda AObjectPYH,x
  sub #1
  sta OAM_YPOS+(4*0),y
  sta OAM_YPOS+(4*1),y
  add #8
  sta OAM_YPOS+(4*2),y
  sta OAM_YPOS+(4*3),y

  pla
  sta OAM_TILE+(4*0),y
  add #1
  sta OAM_TILE+(4*2),y
  add #1
  sta OAM_TILE+(4*1),y
  add #1
  sta OAM_TILE+(4*3),y

  lda #OAM_COLOR_1
  sta OAM_ATTR+(4*0),y
  sta OAM_ATTR+(4*1),y
  sta OAM_ATTR+(4*2),y
  sta OAM_ATTR+(4*3),y

  lda Flags
  and #ADRAW_HMIRROR
  beq :+
    lda OAM_TILE+(4*2),y
    sta OAM_TILE+(4*3),y
    lda OAM_TILE+(4*0),y
    sta OAM_TILE+(4*1),y

    lda #OAM_COLOR_1+OAM_XFLIP
    sta OAM_ATTR+(4*1),y
    sta OAM_ATTR+(4*3),y
    lda retraces      
  :

  lda AObjectPXH,x
  sta OAM_XPOS+(4*0),y
  sta OAM_XPOS+(4*2),y
  add #8
  sta OAM_XPOS+(4*1),y
  sta OAM_XPOS+(4*3),y

  lda Flags
  and #ADRAW_VMIRROR
  beq :+
    lda OAM_TILE+(4*2),y
    sta OAM_TILE+(4*1),y
    sta OAM_TILE+(4*3),y
    lda OAM_TILE+(4*0),y
    sta OAM_TILE+(4*2),y
    lda #OAM_COLOR_1+OAM_YFLIP
    sta OAM_ATTR+(4*2),y
    sta OAM_ATTR+(4*3),y
  :

  lda Flags
  and #ADRAW_HFLIP
  beq :+
    lda OAM_TILE+(4*0),y
    pha
    lda OAM_TILE+(4*1),y
    sta OAM_TILE+(4*0),y
    pla
    sta OAM_TILE+(4*1),y

    lda OAM_TILE+(4*2),y
    pha
    lda OAM_TILE+(4*3),y
    sta OAM_TILE+(4*2),y
    pla
    sta OAM_TILE+(4*3),y

    lda #OAM_COLOR_1+OAM_XFLIP
    sta OAM_ATTR+(4*0),y
    sta OAM_ATTR+(4*1),y
    lda #OAM_COLOR_1+OAM_XFLIP+OAM_YFLIP
    sta OAM_ATTR+(4*2),y
    sta OAM_ATTR+(4*3),y
  :

  tya
  add #4*4
  sta OamPtr
.if 0
  lda GunX
  add #4
  sta OAM_XPOS+(4*4),y
  lda GunY
  add #3
  sta OAM_YPOS+(4*4),y
  txa
  sta OAM_ATTR+(4*4),y
  lda #$1d
  sta OAM_TILE+(4*4),y
.endif
  rts
.endproc

.if 0
.proc BObjectDraw
  pha
  ldy OamPtr

  lda BObjectPY,x
  sub #1
  sta OAM_YPOS+(4*0),y
  sta OAM_YPOS+(4*1),y
  add #8
  sta OAM_YPOS+(4*2),y
  sta OAM_YPOS+(4*3),y

  pla
  sta OAM_TILE+(4*0),y
  add #1
  sta OAM_TILE+(4*2),y
  add #1
  sta OAM_TILE+(4*1),y
  add #1
  sta OAM_TILE+(4*3),y

  lda #OAM_COLOR_1
  sta OAM_ATTR+(4*0),y
  sta OAM_ATTR+(4*1),y
  sta OAM_ATTR+(4*2),y
  sta OAM_ATTR+(4*3),y

  lda BObjectPX,x
  sta OAM_XPOS+(4*0),y
  sta OAM_XPOS+(4*2),y
  add #8
  sta OAM_XPOS+(4*1),y
  sta OAM_XPOS+(4*3),y
  tya
  add #4*4
  sta OamPtr
  rts
.endproc
.endif

.if 0
AObjectUpdateVelocityIfNeeded:
  pha
  lda AObjectVXH,x
  ora AObjectVYH,x
  ora AObjectVXL,x
  ora AObjectVYL,x
  beq :+
  lda AObjectLastAngle
  cmp AObjectAngle,x
  bne :+
  pla
  rts
: pla
.endif
.proc AObjectUpdateVelocity ; A = speed
  ldy AObjectAngle,x
  jsr SpeedAngle2Offset ; A = speed, Y = angle -> 0,1(X) 2,3(Y)
  lda 0
  sta AObjectVXL,x
  lda 1
  sta AObjectVXH,x
  lda 2
  sta AObjectVYL,x
  lda 3
  sta AObjectVYH,x
  rts
.endproc

.proc AObjectCheckBounce
Bumped = 0
Temp = 1
CheckX = 2
CheckY = 3
  lda AObjectVXH,x
  bmi :+
    add #15
: add AObjectPXH,x
  sta CheckX

  lsr
  lsr
  lsr
  lsr
  sta Temp
  lda AObjectPYH,x
  add #8
  and #$f0
  ora Temp
  tay
  lda LevelBuf,y
  cmp #METATILE_SOLID
  bcc NoTouchH
    inc Bumped
    lda #16
    sub AObjectAngle,x
    bpl :+
    add #32
  : sta AObjectAngle,x
  NoTouchH:
; ---------------------
  lda AObjectVYH,x
  bmi :+
    add #15
: add AObjectPYH,x
  sta CheckY

  and #$f0
  sta Temp
  lda AObjectPXH,x
  add #8
  lsr
  lsr
  lsr
  lsr
  ora Temp
  tay
  lda LevelBuf,y
  cmp #METATILE_SOLID
  bcc NoTouchV
    inc Bumped
    lda AObjectAngle,x
    eor #255
    add #1
    and #31
    sta AObjectAngle,x
  NoTouchV:
  rts
.endproc

.proc AObjectApplyVelocity
  lda AObjectPXL,x
  add AObjectVXL,x
  sta AObjectPXL,x
  lda AObjectPXH,x
  adc AObjectVXH,x
  sta AObjectPXH,x

  lda AObjectPYL,x
  add AObjectVYL,x
  sta AObjectPYL,x
  lda AObjectPYH,x
  adc AObjectVYH,x
  sta AObjectPYH,x
  rts
.endproc

.proc AObjectGetShot
  lda AObjectPYH,x
  add #8
  lsr
  lsr
  and #%111000
  sta TempVal
  lda AObjectPXH,x
  add #4
  lsr ; / 32 pixels
  lsr
  lsr
  lsr
  lsr
  ora TempVal
  tay
  lda BulletMap,y
  beq Exit

  ldy #0
BulletLoop:
  lda BulletF,y
  and #%11000000
  cmp #%11000000 ;enabled, player-made bullets only
  bne SkipBullet

  lda BulletPXH,y
  sta TouchLeftA
  lda BulletPYH,y
  sta TouchTopA

  lda AObjectPXH,x
  sta TouchLeftB
  lda AObjectPYH,x
  sta TouchTopB

  lda #8
  sta TouchWidthA
  sta TouchHeightA
  asl
  sta TouchWidthB
  sta TouchHeightB

  jsr ChkTouchGeneric
  bcs ShotHit
SkipBullet:
  iny
  cpy #BulletLen
  bne BulletLoop
Exit:
  clc
  rts
ShotHit:
  lda #0
  sta BulletF,y
  sec
  rts
.endproc

.proc AObjectGetHurtFromShot
  bcc :+
  lda AObjectF1,x
  and #%11100000
  beq Killed
  sub #%00100000
  ora AObjectF1,x
  sta AObjectF1,x
  lda #SOUND_ENEMYHURT2
  sta NeedSound
: rts

Killed:
  lda #0
  sta AObjectF1,x

  lda EnemiesLeftForNextLevel
  beq :+
  dec EnemiesLeftForNextLevel
:

  jsr huge_rand
  and #7
  cmp #4
  bcs :+
    add #AOBJECT_PICKUP_AMMO
    sta AObjectF1,x
    lda #160
    sta AObjectTimer,x
  :

  lda #SOUND_ENEMYHURT
  sta NeedSound
  pla
  pla
  rts
.endproc

.proc AObjectPlayerTouch
  ldy #0
PlayerLoop:
  lda PlayerEnabled,y
  beq NotTouched

  lda PlayerPXH,y
  sta TouchLeftA
  lda PlayerPYH,y
  sta TouchTopA

  lda AObjectPXH,x
  sta TouchLeftB
  lda AObjectPYH,x
  sta TouchTopB

  lda #16
  sta TouchWidthB
  sta TouchWidthA
  sta TouchHeightA
  sta TouchHeightB

  jsr ChkTouchGeneric
  bcc NotTouched

  jsr huge_rand
  lsr
  and #7
  add AObjectAngle,x
  add #16-8
  and #31
  sta AObjectAngle,x

  lda PlayerInvincible,y
  beq :+
    clc
    rts
  :

  jsr huge_rand
  lsr
  and #7
  add PlayerAngle,y
  add #16-8
  and #31
  sta PlayerAngle,y
  sty PlayerThatTouched

  sec
  rts
NotTouched:
  iny
  cpy #NumPlayers
  bne PlayerLoop
  clc
  rts
.endproc

.proc SpawnEnemies
  lda retraces
  and #63
  bne Exit
  ldx #0
  lda #0
  sta 0
: lda AObjectF1,x
  cmp #1
  lda #0
  adc 0
  sta 0
  inx
  cpx #AObjectLen
  bne :-

  ; need more enemies?
  lda 0
  cmp MaxScreenEnemies
  bcc :+
Exit:
  rts
: ; make new enemy

  jsr FindFreeAObjectX
  bcs :+
  rts
:
  jsr huge_rand ; pick an angle
  and #31
  sta 0
  tay
  lda CosineTable,y
  asl
  add #128-8
  sta AObjectPXH,x
  lda SineTable,y
  asl
  add #128-8
  sta AObjectPYH,x
  lda #0
  sta AObjectPXL,x
  sta AObjectPYL,x
  sta AObjectVXL,x
  sta AObjectVXH,x
  sta AObjectVYL,x
  sta AObjectVYH,x
  sta AObjectF2,x
  sta AObjectF3,x

  jsr huge_rand
  lsr
  lsr
  and #3
  tay
  lda EnemiesPool,y
;  lda #AOBJECT_SPINNER ;AOBJECT_CANNON1
  sta AObjectF1,x

  lda 0
  add #16
  and #31
  sta AObjectAngle,x
  rts
.endproc

.proc FindFreeAObjectX ; carry = success
  pha
  ldx #0
: lda AObjectF1,x
  beq Found
  inx
  cpx #AObjectLen
  bne :-
NotFound:
  pla
  clc
  rts
Found:
  pla
  sec
  rts
.endproc

.if 0
.proc FindFreeBObjectX ; carry = success
  pha
  ldx #0
: lda BObjectF1,x
  beq Found
  inx
  cpx #BObjectLen
  bne :-
NotFound:
  pla
  clc
  rts
Found:
  pla
  sec
  rts
.endproc
.endif
