.proc UpdateScrollColumn
  WhichMetaColumn = 1
  LevelBufIndex = 2
  NewColumn = StatusRow2

; calculate PPU address to write the 28 byte buffer to
; (repurposed from being a status bar)
  lda #$20
  sta Update28Address+0
  lda ScrollX+1
  lsr
  lsr
  lsr
  sta 0 ; nametable column used to determine what level column to update
  add #64
  sta Update28Address+1

  ldy #0 ; y will be Update28 index
  sty WhichMetaColumn
  lda 0
  lsr   ; get the LevelBuf index
  sta LevelBufIndex
  jcs RenderRight

; generate new level stuff here, if left column
  ldx #15
  lda #0
: sta NewColumn,x
  dex
  bpl :-

  jsr huge_rand
  and #15
  tax
  lda #METATILE_SOLID
  sta NewColumn,x

  ldy #0
RenderLeft:
  tya
  lsr
  tax
  lda NewColumn,x
  sta TempVal

  lda LevelBufIndex ; step to next metatile
  tax               ; but for this iteration, use the previous value
  add #16
  sta LevelBufIndex

  lda TempVal
  sta LevelBuf+16,x ; find index into MetatileData
  asl
  asl
  tax

  lda MetatileTiledata,x
  sta Update28+0,y
  lda MetatileTiledata+2,x
  sta Update28+1,y

  iny
  iny
  cpy #28
  bne RenderLeft
  rts

RenderRight:
  lda LevelBufIndex ; step to next metatile
  tax               ; but for this iteration, use the previous value
  add #16
  sta LevelBufIndex

  lda LevelBuf+16,x ; find index into MetatileData
  asl
  asl
  tax

  lda MetatileTiledata+1,x
  sta Update28+0,y
  lda MetatileTiledata+3,x
  sta Update28+1,y

  iny
  iny
  cpy #28
  bne RenderLeft
  rts
.endproc

.enum
  SCROLLCOL_EMPTY
  SCROLLCOL_GROUND
  SCROLLCOL_MIDGROUND
  SCROLLCOL_HIGHGROUND
  SCROLLCOL_SPRINGGROUND
  SCROLLCOL_ALLGROUND
.endenum

MulTable16:
  .byt $00, $10, $20, $30, $40, $50, $60, $70, $80, $90, $a0, $b0, $c0, $d0, $e0, $f0
.proc ScrollColumnTemplates ; backwards
  .byt 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0
  .byt METATILE_SOLID, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0
  .byt METATILE_SOLID, METATILE_SOLID, METATILE_SOLID, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0
  .byt METATILE_SOLID, METATILE_SOLID, METATILE_SOLID, METATILE_SOLID, METATILE_SOLID, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0
  .byt METATILE_SOLID, METATILE_SOLID, METATILE_SOLID, METATILE_SOLID, METATILE_SOLID, METATILE_SOLID, METATILE_SOLID, 0, 0, 0, 0, 0, 0, 0, 0, 0
  .byt METATILE_SOLID,METATILE_SOLID,METATILE_SOLID,METATILE_SOLID,METATILE_SOLID,METATILE_SOLID,METATILE_SOLID,METATILE_SOLID, METATILE_SOLID,METATILE_SOLID,METATILE_SOLID,METATILE_SOLID,METATILE_SOLID,METATILE_SOLID,METATILE_SOLID,METATILE_SOLID
  .byt 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0
  .byt 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0
  .byt 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0
  .byt 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0
  .byt 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0
.endproc
